build.sh 19 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | grep Xcode)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcpretty
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcpretty_cmd=(xcpretty)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  102. if [[ $result == 65 ]]; then
  103. ExportLogs "$@"
  104. echo "xcodebuild exited with 65, retrying" 1>&2
  105. sleep 5
  106. result=0
  107. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  108. fi
  109. if [[ $result != 0 ]]; then
  110. echo "xcodebuild exited with $result" 1>&2
  111. ExportLogs "$@"
  112. return $result
  113. fi
  114. }
  115. # Exports any logs output captured in the xcresult
  116. function ExportLogs() {
  117. python "${scripts_dir}/xcresult_logs.py" "$@"
  118. }
  119. if [[ "$xcode_major" -lt 15 ]]; then
  120. ios_flags=(
  121. -sdk 'iphonesimulator'
  122. -destination 'platform=iOS Simulator,name=iPhone 14'
  123. )
  124. else
  125. ios_flags=(
  126. -sdk 'iphonesimulator'
  127. -destination 'platform=iOS Simulator,name=iPhone 15'
  128. )
  129. fi
  130. ios_device_flags=(
  131. -sdk 'iphoneos'
  132. -destination 'generic/platform=iOS'
  133. )
  134. ipad_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  137. )
  138. macos_flags=(
  139. -sdk 'macosx'
  140. -destination 'platform=OS X,arch=x86_64'
  141. )
  142. tvos_flags=(
  143. -sdk "appletvsimulator"
  144. -destination 'platform=tvOS Simulator,name=Apple TV'
  145. )
  146. watchos_flags=(
  147. -sdk 'watchsimulator'
  148. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)'
  149. )
  150. visionos_flags=(
  151. -sdk 'xrsimulator'
  152. -destination 'platform=visionOS Simulator,name=Apple Vision Pro'
  153. )
  154. catalyst_flags=(
  155. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  156. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  157. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  158. )
  159. # Compute standard flags for all platforms
  160. case "$platform" in
  161. iOS)
  162. xcb_flags=("${ios_flags[@]}")
  163. gen_platform=ios
  164. ;;
  165. iOS-device)
  166. xcb_flags=("${ios_device_flags[@]}")
  167. gen_platform=ios
  168. ;;
  169. iPad)
  170. xcb_flags=("${ipad_flags[@]}")
  171. ;;
  172. macOS)
  173. xcb_flags=("${macos_flags[@]}")
  174. gen_platform=macos
  175. ;;
  176. tvOS)
  177. xcb_flags=("${tvos_flags[@]}")
  178. gen_platform=tvos
  179. ;;
  180. watchOS)
  181. xcb_flags=("${watchos_flags[@]}")
  182. ;;
  183. visionOS)
  184. xcb_flags=("${visionos_flags[@]}")
  185. ;;
  186. catalyst)
  187. xcb_flags=("${catalyst_flags[@]}")
  188. ;;
  189. all)
  190. xcb_flags=()
  191. ;;
  192. Linux)
  193. xcb_flags=()
  194. ;;
  195. *)
  196. echo "Unknown platform '$platform'" 1>&2
  197. exit 1
  198. ;;
  199. esac
  200. xcb_flags+=(
  201. ONLY_ACTIVE_ARCH=YES
  202. CODE_SIGNING_REQUIRED=NO
  203. CODE_SIGNING_ALLOWED=YES
  204. COMPILER_INDEX_STORE_ENABLE=NO
  205. )
  206. source scripts/buildcache.sh
  207. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  208. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  209. # Right now, it makes the log overflow on Travis because many of our
  210. # dependencies don't build cleanly this way.
  211. cmake_options=(
  212. -Wdeprecated
  213. -DCMAKE_BUILD_TYPE=Debug
  214. )
  215. if [[ -n "${SANITIZERS:-}" ]]; then
  216. for sanitizer in $SANITIZERS; do
  217. case "$sanitizer" in
  218. asan)
  219. xcb_flags+=(
  220. -enableAddressSanitizer YES
  221. )
  222. cmake_options+=(
  223. -DWITH_ASAN=ON
  224. )
  225. ;;
  226. tsan)
  227. xcb_flags+=(
  228. -enableThreadSanitizer YES
  229. )
  230. cmake_options+=(
  231. -DWITH_TSAN=ON
  232. )
  233. ;;
  234. ubsan)
  235. xcb_flags+=(
  236. -enableUndefinedBehaviorSanitizer YES
  237. )
  238. cmake_options+=(
  239. -DWITH_UBSAN=ON
  240. )
  241. ;;
  242. *)
  243. echo "Unknown sanitizer '$sanitizer'" 1>&2
  244. exit 1
  245. ;;
  246. esac
  247. done
  248. fi
  249. case "$product-$platform-$method" in
  250. FirebasePod-iOS-*)
  251. RunXcodebuild \
  252. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  253. -scheme "FirebasePodTest" \
  254. "${xcb_flags[@]}" \
  255. build
  256. ;;
  257. Auth-*-*)
  258. if check_secrets; then
  259. RunXcodebuild \
  260. -project 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcodeproj' \
  261. -scheme "$method" \
  262. "${xcb_flags[@]}" \
  263. test
  264. fi
  265. ;;
  266. CombineSwift-*-xcodebuild)
  267. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  268. RunXcodebuild \
  269. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  270. -scheme "FirebaseCombineSwift-Unit-unit" \
  271. "${xcb_flags[@]}" \
  272. build \
  273. test
  274. ;;
  275. InAppMessaging-*-xcodebuild)
  276. RunXcodebuild \
  277. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  278. -scheme 'FiamDisplaySwiftExample' \
  279. "${xcb_flags[@]}" \
  280. test
  281. ;;
  282. Firestore-*-xcodebuild)
  283. "${firestore_emulator}" start
  284. trap '"${firestore_emulator}" stop' ERR EXIT
  285. RunXcodebuild \
  286. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  287. -scheme "Firestore_IntegrationTests_$platform" \
  288. -enableCodeCoverage YES \
  289. "${xcb_flags[@]}" \
  290. test
  291. ;;
  292. Firestore-macOS-cmake | Firestore-Linux-cmake)
  293. "${firestore_emulator}" start
  294. trap '"${firestore_emulator}" stop' ERR EXIT
  295. (
  296. test -d build || mkdir build
  297. cd build
  298. echo "Preparing cmake build ..."
  299. cmake -G Ninja "${cmake_options[@]}" ..
  300. echo "Building cmake build ..."
  301. ninja -k 10 all
  302. ctest --verbose
  303. )
  304. ;;
  305. SymbolCollision-*-*)
  306. RunXcodebuild \
  307. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  308. -scheme "SymbolCollisionTest" \
  309. "${xcb_flags[@]}" \
  310. build
  311. ;;
  312. # TODO(#12205) Restore this test to "test" instead of "build"
  313. Messaging-*-xcodebuild)
  314. pod_gen FirebaseMessaging.podspec --platforms=ios
  315. # Add GoogleService-Info.plist to generated Test Wrapper App.
  316. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  317. AppHost-FirebaseMessaging-Unit-Tests \
  318. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  319. if check_secrets; then
  320. # Integration tests are only run on iOS to minimize flake failures.
  321. RunXcodebuild \
  322. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  323. -scheme "FirebaseMessaging-Unit-integration" \
  324. "${ios_flags[@]}" \
  325. "${xcb_flags[@]}" \
  326. build
  327. fi
  328. ;;
  329. MessagingSample-*-*)
  330. if check_secrets; then
  331. RunXcodebuild \
  332. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  333. -scheme "Sample" \
  334. "${xcb_flags[@]}" \
  335. build
  336. fi
  337. ;;
  338. SwiftUISample-*-*)
  339. if check_secrets; then
  340. RunXcodebuild \
  341. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  342. -scheme "SwiftUISample" \
  343. "${xcb_flags[@]}" \
  344. build
  345. fi
  346. ;;
  347. # TODO: This is actually building for iOS instead of watchOS. Update to use
  348. # watchOS xcb_flags along with the watchOS sdk option. Also nanopb and promises
  349. # podspecs need minimum version updates.
  350. MessagingSampleStandaloneWatchApp-*-*)
  351. if check_secrets; then
  352. RunXcodebuild \
  353. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  354. -scheme "SampleStandaloneWatchApp Watch App" \
  355. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)' \
  356. build
  357. fi
  358. ;;
  359. MLModelDownloaderSample-*-*)
  360. if check_secrets; then
  361. RunXcodebuild \
  362. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  363. -scheme "MLDownloaderTestApp" \
  364. "${xcb_flags[@]}" \
  365. build
  366. fi
  367. ;;
  368. WatchOSSample-*-*)
  369. RunXcodebuild \
  370. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  371. -scheme "SampleWatchAppWatchKitApp" \
  372. "${xcb_flags[@]}" \
  373. build
  374. ;;
  375. Database-*-integration)
  376. "${database_emulator}" start
  377. trap '"${database_emulator}" stop' ERR EXIT
  378. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  379. RunXcodebuild \
  380. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  381. -scheme "FirebaseDatabase-Unit-integration" \
  382. "${xcb_flags[@]}" \
  383. build \
  384. test
  385. ;;
  386. RemoteConfig-*-fakeconsole)
  387. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  388. RunXcodebuild \
  389. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  390. -scheme "FirebaseRemoteConfig-Unit-fake-console-tests" \
  391. "${xcb_flags[@]}" \
  392. build \
  393. test
  394. ;;
  395. RemoteConfig-*-integration)
  396. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  397. # Add GoogleService-Info.plist to generated Test Wrapper App.
  398. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  399. AppHost-FirebaseRemoteConfig-Unit-Tests \
  400. ../../../FirebaseRemoteConfig/Tests/Swift/SwiftAPI/GoogleService-Info.plist
  401. # Add AccessToken to generated Test Wrapper App.
  402. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  403. AppHost-FirebaseRemoteConfig-Unit-Tests \
  404. ../../../FirebaseRemoteConfig/Tests/Swift/AccessToken.json
  405. RunXcodebuild \
  406. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  407. -scheme "FirebaseRemoteConfig-Unit-swift-api-tests" \
  408. "${xcb_flags[@]}" \
  409. build \
  410. test
  411. ;;
  412. RemoteConfigSample-*-*)
  413. RunXcodebuild \
  414. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  415. -scheme "RemoteConfigSampleApp" \
  416. "${xcb_flags[@]}" \
  417. build
  418. ;;
  419. VertexSample-*-*)
  420. RunXcodebuild \
  421. -project 'FirebaseVertexAI/Sample/VertexAISample.xcodeproj' \
  422. -scheme "VertexAISample" \
  423. "${xcb_flags[@]}" \
  424. build
  425. ;;
  426. Sessions-*-integration)
  427. # Perform "pod install" to install the relevant dependencies
  428. # ./FirebaseSessions/generate_testapp.sh
  429. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  430. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  431. # Run E2E Integration Tests for Prod.
  432. RunXcodebuild \
  433. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  434. -scheme "AppQualityDevApp_iOS" \
  435. "${ios_flags[@]}" \
  436. "${xcb_flags[@]}" \
  437. build \
  438. test
  439. # Run E2E Integration Tests for Staging.
  440. RunXcodebuild \
  441. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  442. -scheme "AppQualityDevApp_iOS" \
  443. FirebaseSessionsRunEnvironment=STAGING \
  444. "${ios_flags[@]}" \
  445. "${xcb_flags[@]}" \
  446. build \
  447. test
  448. # Run E2E Integration Tests for Autopush.
  449. RunXcodebuild \
  450. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  451. -scheme "AppQualityDevApp_iOS" \
  452. FirebaseSessionsRunEnvironment=AUTOPUSH \
  453. "${ios_flags[@]}" \
  454. "${xcb_flags[@]}" \
  455. build \
  456. test
  457. ;;
  458. StorageSwift-*-xcodebuild)
  459. pod_gen FirebaseStorage.podspec --platforms=ios
  460. # Add GoogleService-Info.plist to generated Test Wrapper App.
  461. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  462. AppHost-FirebaseStorage-Unit-Tests \
  463. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  464. if check_secrets; then
  465. # Integration tests are only run on iOS to minimize flake failures.
  466. RunXcodebuild \
  467. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  468. -scheme "FirebaseStorage-Unit-integration" \
  469. "${ios_flags[@]}" \
  470. "${xcb_flags[@]}" \
  471. test
  472. fi
  473. ;;
  474. StorageObjC-*-xcodebuild)
  475. pod_gen FirebaseStorage.podspec --platforms=ios
  476. # Add GoogleService-Info.plist to generated Test Wrapper App.
  477. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  478. AppHost-FirebaseStorage-Unit-Tests \
  479. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  480. if check_secrets; then
  481. # Integration tests are only run on iOS to minimize flake failures.
  482. RunXcodebuild \
  483. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  484. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  485. "${ios_flags[@]}" \
  486. "${xcb_flags[@]}" \
  487. test
  488. fi
  489. ;;
  490. StorageCombine-*-xcodebuild)
  491. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  492. # Add GoogleService-Info.plist to generated Test Wrapper App.
  493. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  494. AppHost-FirebaseCombineSwift-Unit-Tests \
  495. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  496. if check_secrets; then
  497. # Integration tests are only run on iOS to minimize flake failures.
  498. RunXcodebuild \
  499. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  500. -scheme "FirebaseCombineSwift-Unit-integration" \
  501. "${ios_flags[@]}" \
  502. "${xcb_flags[@]}" \
  503. test
  504. fi
  505. ;;
  506. GoogleDataTransport-watchOS-xcodebuild)
  507. RunXcodebuild \
  508. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  509. -scheme "GDTWatchOSTestAppWatchKitApp" \
  510. "${xcb_flags[@]}" \
  511. build
  512. RunXcodebuild \
  513. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  514. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  515. "${xcb_flags[@]}" \
  516. build
  517. RunXcodebuild \
  518. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  519. -scheme "GDTCCTWatchOSCompanionTestApp" \
  520. "${xcb_flags[@]}" \
  521. build
  522. ;;
  523. Performance-*-unit)
  524. # Run unit tests on prod environment with unswizzle capabilities.
  525. export FPR_UNSWIZZLE_AVAILABLE="1"
  526. export FPR_AUTOPUSH_ENV="0"
  527. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  528. RunXcodebuild \
  529. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  530. -scheme "FirebasePerformance-Unit-unit" \
  531. "${xcb_flags[@]}" \
  532. build \
  533. test
  534. ;;
  535. Performance-*-proddev)
  536. # Build the prod dev test app.
  537. export FPR_UNSWIZZLE_AVAILABLE="0"
  538. export FPR_AUTOPUSH_ENV="0"
  539. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  540. RunXcodebuild \
  541. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  542. -scheme "FirebasePerformance-TestApp" \
  543. "${xcb_flags[@]}" \
  544. build
  545. ;;
  546. Performance-*-integration)
  547. # Generate the workspace for the SDK to generate Protobuf files.
  548. export FPR_UNSWIZZLE_AVAILABLE="0"
  549. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  550. # Perform "pod install" to install the relevant dependencies
  551. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  552. # Run E2E Integration Tests for Autopush.
  553. RunXcodebuild \
  554. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  555. -scheme "FIRPerfE2EAutopush" \
  556. FPR_AUTOPUSH_ENV=1 \
  557. "${ios_flags[@]}" \
  558. "${xcb_flags[@]}" \
  559. build \
  560. test
  561. # Run E2E Integration Tests for Prod.
  562. RunXcodebuild \
  563. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  564. -scheme "FIRPerfE2EProd" \
  565. "${ios_flags[@]}" \
  566. "${xcb_flags[@]}" \
  567. build \
  568. test
  569. ;;
  570. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  571. *-*-spm)
  572. RunXcodebuild \
  573. -scheme $product \
  574. "${xcb_flags[@]}" \
  575. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  576. TVOS_DEPLOYMENT_TARGET=13.0 \
  577. test
  578. ;;
  579. *-*-spmbuildonly)
  580. RunXcodebuild \
  581. -scheme $product \
  582. "${xcb_flags[@]}" \
  583. build
  584. ;;
  585. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  586. RunXcodebuild \
  587. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  588. -scheme $product \
  589. "${xcb_flags[@]}" \
  590. build
  591. ;;
  592. ClientApp-CocoaPods*-iOS-xcodebuild)
  593. RunXcodebuild \
  594. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  595. -scheme $product \
  596. "${xcb_flags[@]}" \
  597. build
  598. ;;
  599. *)
  600. echo "Don't know how to build this product-platform-method combination" 1>&2
  601. echo " product=$product" 1>&2
  602. echo " platform=$platform" 1>&2
  603. echo " method=$method" 1>&2
  604. exit 1
  605. ;;
  606. esac